﻿using Apexconnect.Common.AdoHelper;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ConcurConnectWeb
{
    public partial class ClientPlatformIntegrations : System.Web.UI.Page
    {
        private string connConfig = ConfigurationManager.ConnectionStrings["Platform_Config"].ConnectionString;
        private string connClient = ConfigurationManager.ConnectionStrings["PLATFORM_CLIENT"].ConnectionString;
        private string connConnect = ConfigurationManager.ConnectionStrings["concurconnect"].ConnectionString;
        public IEnumerable data;
        protected int clientID = 0;
        protected string clientKey = "";
        protected void Page_Load(object sender, EventArgs e)
        {

            if (Request.QueryString["CID"] != null)
            {
                clientID = int.Parse(Request.QueryString["CID"].ToString());
            }
            else
            {
                clientID = 0;
            }

            if (!IsPostBack)
            {
                var appCfg = Session["AppCfg"] as AppConfig;
                if (appCfg == null)
                {
                    //Redirect to login
                    Response.Redirect("AppAdmin.aspx?r=" + Request.Url.AbsoluteUri);

                }
                else
                {
                    if (clientID == 0)
                    {
                        Response.Redirect("ConcurClients.aspx");
                    }

                    UpdateFromPlat();

                    GetData(clientID);

                    SetDDlData();

                    //this.data = Ints.AsEnumerable();
                }
            }
        }
        protected void UpdateFromPlat()
        {
            var args = new SqlHelperArgumentCollection();
            args.Add("@p_RequestedBy", SqlDbType.VarChar, Environment.UserName, ParameterDirection.Input, 50);

           SqlHelper.ExecuteSql(connConnect, "usp_ClientPlatformIntegrationSetting_UpdateFromPlat", args, CommandType.StoredProcedure);            

        }
        protected void GetData(int clientID)
        {
            var args = new SqlHelperArgumentCollection();
            args.Add("@p_ClientId", SqlDbType.Int, clientID, ParameterDirection.Input);
            args.Add("@p_RequestedBy", SqlDbType.VarChar, Environment.UserName, ParameterDirection.Input,50);

            DataTable IntSettings = SqlHelper.FetchDataTable(connConnect, "usp_ClientPlatformIntegrationSetting_Get", args, CommandType.StoredProcedure);
            if (IntSettings.Rows.Count > 0)
            {
                clientKey = IntSettings.Rows[0][1].ToString();
            }
            grdData.DataSource = IntSettings;
            grdData.DataBind();

        }
        protected void SetDDlData()
        {
            var args = new SqlHelperArgumentCollection();

            args.Add("@p_ClientId", SqlDbType.Int, clientID, ParameterDirection.Input);
            args.Add("@p_RequestedBy", SqlDbType.VarChar, Environment.UserName, ParameterDirection.Input, 50);

            DataTable Ints = SqlHelper.FetchDataTable(connConnect, "usp_CLIENT_PLATFORM_INTEGRATION_CONFIG_GET", args, CommandType.StoredProcedure);
            if (Ints.Rows.Count > 0)
            {
                this.data = Ints.AsEnumerable()
                                .Select(r => new
                                {
                                    INTEGRATIONKEY = r.Field<Guid>("INTEGRATIONKEY"),
                                    INTEGRATIONNAME = r.Field<string>("INTEGRATIONNAME")
                                });
            }
            else
            {
                grdData.EditSettings.AllowAdding = false;
            }
        }

        protected void grdData_ServerBatchEditRow(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {

        }

        protected void grdData_ServerEditRow(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            EditLineAction(e.EventType, e.Arguments);
        }

        protected void grdData_ServerCommandButtonClick(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {

        }
        private void EditLineAction(string eventType, object record)
        {
            Dictionary<string, object> KeyVal = record as Dictionary<string, object>;
           
            Dictionary<string, object> KeyVal2 = new Dictionary<string, object>();

            foreach (KeyValuePair<string, object> cell in KeyVal)
            {
                if (cell.Key == "rowData")
                {
                    KeyVal2 = cell.Value as Dictionary<string, object>;
                }

            }
            int extract = KeyVal2["EXTRACT"].ToString() == "True" ? 1 : 0;
            int uI = KeyVal2["UI"].ToString() == "True" ? 1 : 0;
            int extractA = KeyVal2["EXTRACT"].ToString() == "on" ? 1 : 0;
            int uIA = KeyVal2["UI"].ToString() == "on" ? 1 : 0;
          
            string integrationName = KeyVal2["INTEGRATIONNAME"].ToString();
            string integrationKey = KeyVal2["INTEGRATIONKEY"].ToString();

            if (eventType == "endEdit")
            {

                int clientId = int.Parse(KeyVal2["CLIENTID"].ToString());
                string clientkey = KeyVal2["CLIENTKEY"].ToString();

                var args = new SqlHelperArgumentCollection();
                args.Add("@p_ClientKey", SqlDbType.UniqueIdentifier, Guid.Parse(clientkey), ParameterDirection.Input);
                args.Add("@p_IsExtract", SqlDbType.Bit, extract, ParameterDirection.Input);
                args.Add("@p_IsUIEnabled", SqlDbType.Bit, uI, ParameterDirection.Input);
                args.Add("@p_IntegrationKey", SqlDbType.UniqueIdentifier, Guid.Parse(integrationKey), ParameterDirection.Input);
                args.Add("@p_RequestedBy", SqlDbType.VarChar, Environment.UserName, ParameterDirection.Input, 50);

                SqlHelper.ExecuteSql(connConnect, "usp_ClientPlatformIntegrationSetting_Update", args, CommandType.StoredProcedure);
                   
            }
            if (eventType == "endAdd")
            {
                DataTable dt = SqlHelper.FetchDataTable(connConnect, $"Select CLIENTKEY FROM CLIENT WHERE CLIENTID = {clientID}", null, CommandType.Text);

                var args = new SqlHelperArgumentCollection();
                args.Add("@p_ClientId", SqlDbType.Int, clientID, ParameterDirection.Input);
                args.Add("@p_ClientKey", SqlDbType.UniqueIdentifier, Guid.Parse(dt.Rows[0][0].ToString()), ParameterDirection.Input);
                args.Add("@p_IsExtract", SqlDbType.Bit, extractA, ParameterDirection.Input);
                args.Add("@p_IsUIEnabled", SqlDbType.Bit, uIA, ParameterDirection.Input);
                args.Add("@p_IntegrationKey", SqlDbType.UniqueIdentifier, Guid.Parse(integrationKey), ParameterDirection.Input);
                args.Add("@p_IntegrationName", SqlDbType.VarChar, integrationName, ParameterDirection.Input, 60);
                args.Add("@p_RequestedBy", SqlDbType.VarChar, Environment.UserName, ParameterDirection.Input, 50);

                SqlHelper.ExecuteSql(connConnect, "usp_ClientPlatformIntegrationSetting_INSERT", args, CommandType.StoredProcedure);

            }
            GetData(clientID);
            SetDDlData();
        }

        protected void grdData_ServerAddRow(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
        {
            EditLineAction(e.EventType, e.Arguments);
        }

       
    }
}